const express = require('express')
const jimp    = require("jimp");
const fs      = require('fs');
const app     = express()
const port    = 5000

app.use(express.static('public_html'))

app.get('/:memeType/:topText/:bottomText', (req, res) => {
  var mt = req.params.memeType;
  var tt = req.params.topText;
  var bt = req.params.bottomText;
  var source = './images/' + mt + '.png';
  var outFileName = Math.floor(Math.random() * 10000) + '.png';
  var path = './public_html/' + outFileName;

  jimp.read(source)
    .then(function (image) {
      loadedImage = image;
      return jimp.loadFont(jimp.FONT_SANS_64_WHITE);
    })
    .then(function (font) {
      loadedImage.print(font, 10, 10, tt);
      loadedImage.print(font, 10, 320, bt);
      return loadedImage.write(path);
    })
    .then(function (data) {
      res.end('/' + outFileName);
    })
    .catch(function (err) {
      console.error(err);
    });

/*
  jimp.read(source, function (err, loadedImage) {
    if (err) { console.log(err); return; }
    jimp.loadFont(jimp.FONT_SANS_64_WHITE, function (err, font) {
      if (err) { console.log(err); return; }
      loadedImage.print(font, 10, 10, tt);
      loadedImage.print(font, 10, 320, bt);
      loadedImage.write(path, function (err, data) {
        if (err) { console.log(err); return; }
          res.end('/' + outFileName);
      });
    });
  });
*/




});

app.listen(port, () => 
  console.log(`App listening at http://localhost:${port}`))
